﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;

namespace WindowsFormsApplication1
{
    public partial class miniPOV : Form
    {
        public miniPOV()
        {
            InitializeComponent();
        }

        int GraphicsArraySize = 69;
        byte[] GraphicsArray = new byte[69];
        Button[,] ButtonArray = new Button[8, 69];
        internal struct ButtonData
        {
            internal int x;
            internal int y;
        }  

        private void btnClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void miniPOV_Load(object sender, EventArgs e)
        {
            int x=0, y = 0;
            int xlocation = 6, ylocation = 20;
            int tmpTabIndex = 0;

            newToolStripMenuItem.Enabled = false;
            openToolStripMenuItem.Enabled = false;
            saveAsToolStripMenuItem.Enabled = false;
            saveToolStripMenuItem.Enabled = false;
            btnSave.Enabled = false;
            btnOpen.Enabled = false;

            foreach (string s in SerialPort.GetPortNames())
            {
                comboBox1.Items.Add(s);
                toolStripComboBox1.Items.Add(s);
            }

            comboBox1.SelectedIndex = 0;
            toolStripComboBox1.SelectedIndex = 0;

            serialPort1.PortName = comboBox1.Text;

            grpSerial.TabIndex = 0;
            btnUpload.TabIndex = 1;
            comboBox1.TabIndex = 2;
            grpFillClear.TabIndex = 3;
            btnFill.TabIndex = 4;
            btnClear.TabIndex = 5;
            grpSaveOpen.TabIndex = 6;
            btnSave.TabIndex = 7;
            btnOpen.TabIndex = 8;
            btnClose.TabIndex = 9;
            grpGraphics.TabIndex = 10;
            grpStatus.TabIndex = 11;
            grpAbout.TabIndex = 12;
            tmpTabIndex = 13;

            for (y = 0; y < GraphicsArraySize; y++)
            {
                GraphicsArray[y] = 0;
            }

            for (y = 0; y < GraphicsArraySize; y++)
            {
                for (x = 0; x < 8; x++)
                {
                    ButtonArray[x, y] = new Button();
                    ButtonArray[x, y].Margin = new Padding(0);
                    ButtonArray[x, y].TabIndex = tmpTabIndex;
                    tmpTabIndex++;
                    ButtonArray[x, y].Size = new Size(12, 12);
                    ButtonArray[x, y].UseVisualStyleBackColor = true;
                    ButtonArray[x, y].Location = new Point(xlocation, ylocation);
                    ylocation += 11;
                    ButtonArray[x, y].FlatStyle = FlatStyle.Flat;
                    ButtonArray[x, y].BackColor = Color.White;
                    ButtonArray[x, y].MouseClick += new MouseEventHandler(ButtonArray_MouseClick);

                    ButtonData tempBtnDat = new ButtonData();
                    tempBtnDat.x = x;
                    tempBtnDat.y = y;
                    ButtonArray[x, y].Tag = tempBtnDat;

                    grpGraphics.Controls.Add(ButtonArray[x, y]);
                }
                xlocation += 11;
                ylocation = 20;
            }
        }
        
        private void ButtonArray_MouseClick(object sender, System.EventArgs e)
        {
            ButtonData tmpBtnDat = new ButtonData();
            int x = 0, y = 0;

            tmpBtnDat = (ButtonData)((Button)sender).Tag;
            x = tmpBtnDat.x;
            y = tmpBtnDat.y;

            if (ButtonArray[x, y].BackColor == Color.Red)
            {
                ButtonArray[x, y].BackColor = Color.White;
            }
            else
            {
                ButtonArray[x, y].BackColor = Color.Red;
            }
        }

        private void btnFill_Click(object sender, EventArgs e)
        {
            int x = 0, y = 0;

            for (y = 0; y < GraphicsArraySize; y++)
            {
                for (x = 0; x < 8; x++)
                {
                    ButtonArray[x, y].BackColor = Color.Red;
                }
            }
        }

        private void btnClear_Click(object sender, EventArgs e)
        {
            int x = 0, y = 0;
            for (y = 0; y < GraphicsArraySize; y++)
            {
                for (x = 0; x < 8; x++)
                {
                    ButtonArray[x, y].BackColor = Color.White;
                }
            }
        }

        private void fillAllToolStripMenuItem_Click(object sender, EventArgs e)
        {
            int x = 0, y = 0;

            for (y = 0; y < GraphicsArraySize; y++)
            {
                for (x = 0; x < 8; x++)
                {
                    ButtonArray[x, y].BackColor = Color.Red;
                }
            }
        }

        private void clearAllToolStripMenuItem_Click(object sender, EventArgs e)
        {
            int x = 0, y = 0;
            for (y = 0; y < GraphicsArraySize; y++)
            {
                for (x = 0; x < 8; x++)
                {
                    ButtonArray[x, y].BackColor = Color.White;
                }
            }
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            toolStripComboBox1.SelectedIndex = comboBox1.SelectedIndex;
            serialPort1.PortName = toolStripComboBox1.Text;
        }

        private void toolStripComboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            comboBox1.SelectedIndex = toolStripComboBox1.SelectedIndex;
            serialPort1.PortName = toolStripComboBox1.Text;
        }

        private void btnUpload_Click(object sender, EventArgs e)
        {
            Upload();   
        }

        private void uploadToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            Upload();
        }
        
        private void Upload()
        {
            int y = 0;
            byte checksum = 0, total = 0 ;
            byte[] packet = new byte[GraphicsArraySize + 1];
            byte[] start = new byte[1];
            int ack = 0;
            int sleepvalue = 10;

            start[0] = 0x02;
            
            this.Enabled = false;
            
            for (y = 0; y < GraphicsArraySize; y++)
            {
                GraphicsArray[y] = 0;
            }

            richTextBox1.Text = "Opening " + serialPort1.PortName + "... ";
            progressBar1.Value += 5;
            this.Refresh();

            serialPort1.PortName = comboBox1.Text;

            if (serialPort1.IsOpen == false)
            {
                serialPort1.Open();
                richTextBox1.Text += "OK\n";
                progressBar1.Value += 5;
                this.Refresh();
                
                //send start
                serialPort1.Write(start, 0, 1);
                richTextBox1.Text += "Connecting... ";
                progressBar1.Value += 5;
                this.Refresh();

                //wait
                System.Threading.Thread.Sleep(sleepvalue);

                //check for acknowledge
                if (serialPort1.BytesToRead > 0)
                {
                    ack = serialPort1.ReadByte();
                    if (ack == 0x06)
                    {
                        richTextBox1.Text += "OK\n";
                        progressBar1.Value += 5;
                        this.Refresh();

                        richTextBox1.Text += "Programming... ";
                        this.Refresh();

                        //convert
                        for (y = 0; y < GraphicsArraySize; y++)
                        {
                            if (ButtonArray[0, y].BackColor == Color.Red)
                                GraphicsArray[y] += 1;
                            if (ButtonArray[1, y].BackColor == Color.Red)
                                GraphicsArray[y] += 2;
                            if (ButtonArray[2, y].BackColor == Color.Red)
                                GraphicsArray[y] += 4;
                            if (ButtonArray[3, y].BackColor == Color.Red)
                                GraphicsArray[y] += 8;
                            if (ButtonArray[4, y].BackColor == Color.Red)
                                GraphicsArray[y] += 16;
                            if (ButtonArray[5, y].BackColor == Color.Red)
                                GraphicsArray[y] += 32;
                            if (ButtonArray[6, y].BackColor == Color.Red)
                                GraphicsArray[y] += 64;
                            if (ButtonArray[7, y].BackColor == Color.Red)
                                GraphicsArray[y] += 128;

                            total += GraphicsArray[y];
                            progressBar1.Value ++;

                            //delay
                            //System.Threading.Thread.Sleep(1);
                            //this.Refresh();
                        }

                        checksum = (byte)(0xff - total);
                        progressBar1.Value = 95;
                        this.Refresh();

                        //arrange packets
                        for (y = 0; y < GraphicsArraySize; y++)
                        {
                            packet[y] = GraphicsArray[y];
                        }
                        packet[y] = checksum;

                        //send
                        serialPort1.Write(packet, 0, GraphicsArraySize + 1);
                        richTextBox1.Text += "OK\n";
                        progressBar1.Value = 99;
                        this.Refresh();

                        //wait
                        System.Threading.Thread.Sleep(sleepvalue*50);
                        progressBar1.Value = 100;

                        //check for acknowledge
                        richTextBox1.Text += "Verifying... ";
                        if (serialPort1.BytesToRead > 0)
                        {
                            ack = serialPort1.ReadByte();
                            if (ack == 0x06)
                            {
                                richTextBox1.Text += "OK\n";
                                this.Refresh();
                                System.Threading.Thread.Sleep(sleepvalue * 10);
                            }
                            else
                            {
                                richTextBox1.Text += "Failed\n";
                                this.Refresh();
                            }
                        }
                        else
                        {
                            richTextBox1.Text += "Failed\n";
                            this.Refresh();
                        }
                    }
                    else
                    {
                        richTextBox1.Text += "Failed\n";
                        this.Refresh();
                    }
                }
                else
                {
                    richTextBox1.Text += "Failed\n";
                    this.Refresh();
                }

                serialPort1.Close();
                richTextBox1.Text += "Done\n";
                this.Refresh();
                System.Threading.Thread.Sleep(sleepvalue * 50);
            }
            progressBar1.Value = 0;
            this.Enabled = true;
        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            About AboutForm = new About();
            AboutForm.Show();
        }
    }
}
